<%
  google_roles = @group.roles.find_all { |role| role.role.nil? and role.show_in_hierarchy }
  dracule_roles = @group.roles.find_all { |role| role.role.nil? and role.show_in_hierarchy }
  def html_for_role(role)
    content = "<strong>#{role.name}</strong>"
    if role.members.count > 0
      role.members.each do |member|
        content << "<div>#{member.full_name}<br>#{member.mail}</div>"
      end
    end
    content
  end
%>
<% if not google_roles.empty? %>
  <script type="text/javascript" src="https://www.google.com/jsapi"></script>
  <script type="text/javascript">
    google.load('visualization', '1', {packages:['orgchart']});
    google.setOnLoadCallback(drawChart);
    function drawChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('number', 'Id');
      data.addColumn('number', 'Parent');
      data.addColumn('string', 'Content');
      <% while not google_roles.empty? %>
        <% role = google_roles.shift %>
        <% google_roles = google_roles + role.roles %>
        data.addRow([{v: <%= role.id %>, f: '<%= html_for_role(role) %>'}, <%= role.role.id unless role.role.nil? %>, null]);
      <% end %>
      var chart = new google.visualization.OrgChart(document.getElementById('google_chart_div'));
      chart.draw(data, {allowHtml:true});
    }
  </script>
  <script type="text/javascript" src="/javascripts/raphael-min.js"></script>
  <script type="text/javascript" src="/javascripts/dracula_graffle.js"></script>
  <script type="text/javascript" src="/javascripts/dracula_graph.js"></script>
  <script type="text/javascript">
    $(function(){
      var g = new Graph();
      
      var role_renderer = function (label){
        return function (r, n) {
          var set = r.set().push(
            r.ellipse(n.point[0], n.point[1], 50, 25).attr({"fill": "#a03033"})).push(
            r.text(n.point[0] + 1, n.point[1] + 1, label).attr({"fill": "#000000"})).push(
            r.text(n.point[0], n.point[1], label).attr({"fill": "#ffffff"}));
          return set;
        }
      };
      
      var member_renderer = function (label) {
        return function (r, n) {
          var set = r.set().push(
            r.text(n.point[0], n.point[1], label).attr({"fill": "#000000", "font-size": 12}));
          return set;
        }
      }
      
      var line_renderer = function (r, n) {
        
      }
      
      <% while not dracule_roles.empty? %>
        <% role = dracule_roles.shift %>
        <% dracule_roles = dracule_roles + role.roles %>
        g.addNode("role-<%= role.id %>", {render: role_renderer("<%= role.name %>")});
        <% unless role.role.nil? %>
          g.addEdge("role-<%= role.id %>", "role-<%= role.role.id %>");
        <% end %>
        <% role.members.each do |member| %>
          g.addNode("member-<%= member.id %>", {label: "<%= member.full_name %>", render: member_renderer("<%= member.full_name %>\n<%= member.mail %>")});
          g.addEdge("role-<%= role.id %>", "member-<%= member.id %>");
        <% end %>
      <% end %>
      
      var layouter = new Graph.Layout.Spring(g);
      layouter.layout();
      
      var renderer = new Graph.Renderer.Raphael('dracula_chart_div', g, 968, 800);
      renderer.draw();
    });
  </script>
<% end %>
